library Utils;

{ Remarque importante concernant la gestion de mmoire de DLL : ShareMem doit
  tre la premire unit de la clause USES de votre bibliothque ET de votre projet
  (slectionnez Projet-Voir source) si votre DLL exporte des procdures ou des
  fonctions qui passent des chanes en tant que paramtres ou rsultats de fonction.
  Cela s'applique  toutes les chanes passes de et vers votre DLL --mme celles
  qui sont imbriques dans des enregistrements et classes. ShareMem est l'unit
  d'interface pour le gestionnaire de mmoire partage BORLNDMM.DLL, qui doit
  tre dploy avec vos DLL. Pour viter d'utiliser BORLNDMM.DLL, passez les
  informations de chanes avec des paramtres PChar ou ShortString. }

uses
  SysUtils,
  ShellApi,
  FileCtrl,
  windows;

Function GetUserFromWindows(strName:pString;NameLen:integer):integer;stdcall;
var
  str:string;
  buffer:array[0..255] of char;
  size:dword;
begin
   size:=256;
   If GetUserName(buffer, size) Then
     str := Copy(buffer,1,254)
   Else
     str := 'Unknown';
   if length(str) < NameLen then NameLen:=length(str);
   CopyMemory(pbyte(pstring(strName)^),pbyte(str),NameLen);
   result:=1;
end;

Function GetShortName(sLongName:pString;cLength:integer):integer;stdcall;
var
   sShortName    : string;
 begin
   sShortName := ExtractShortPathName(sLongName^);
   while (length(sShortName)<cLength) do sShortName := sShortName+' ';
   CopyMemory(pbyte(sLongName^),pbyte(sShortName),cLength);
   result:= 1;
 end;

Function GetDirectory(PanoStr,PanoTitle:pstring;PanoLen:integer):integer;stdcall;
var
 chemin:string;
begin
  result := 1;
  if not SelectDirectory(PanoTitle^, '',chemin) then result := 0
  else begin
    while (length(chemin)<PanoLen) do chemin := chemin+' ';
    CopyMemory(pbyte(PanoStr^),pbyte(chemin),PanoLen)
  end
end;


Function Execute(PanoStr:pstring):integer;stdcall;
begin
  ShellExecute(0,nil,Pchar(PanoStr^),nil,Nil,0);
  result := 1;
end;

Function ExecuteAndWait(PanoStr:pstring):integer;stdcall;
var
  StartInfo:TStartupInfo;
  ProcInfo:TProcessInformation;
  CreateOk:Boolean;
begin
  Fillchar(StartInfo,Sizeof(TStartupInfo),#0);
  Fillchar(ProcInfo,Sizeof(TProcessInformation),#0);
  StartInfo.cb := SizeOf(TStartupInfo);
  StartInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartInfo.wShowWindow := SW_HIDE;
  CreateOK := CreateProcess(nil, PChar(PanoStr^), nil, nil,False,
              CREATE_NEW_PROCESS_GROUP+NORMAL_PRIORITY_CLASS,
              nil, nil, StartInfo, ProcInfo);
  if CreateOK then begin
    WaitForSingleObject(ProcInfo.hProcess, INFINITE);
    result := 1;
  end
  else result := 0;
end;


exports
 GetUserFromWindows,
 ExecuteAndWait,
 Execute,
 GetDirectory,
 GetShortName;

begin
end.
